/* first c program to go with the article */
/* this is program getver.c     */
/* (c) 1985,88 Pan-Dimensional Research
    5901 Colfax Ave.
    North Hollywood , Ca.   91601
    Michael Liska

*/


#include <stdio.h>   /* use the standard io package */
#include <math.h>   /* so we can use big numbers */
char version[20];   /* storage for the version information */


/* main()

     {
		double ent_start;  /* place to store the entity start */
                FILE *dwgptr;      /* c's internal name for the file */

                   /* open the file with some safety */
          if((dwgptr = fopen("test.dwg","rb")) == NULL){
                 printf("\nCan't open file for some reason");
                 exit(1); }

          fread(version, sizeof(version),1,dwgptr);   /* read the version */
          fread(&ent_start,sizeof(ent_start),1,dwgptr); /* now we know */

	  fseek(dwgptr,ent_start,0);  /* go there */

	 printf("\nVersion %s  Entities start at %lX",version,ent_start);
	 fclose(dwgptr);
     } */


struct what_ent_is {
                     char name;
		     char byflags;
		     char size;
		     char next_time;
		     char layer;
		     char more_flags;
		     int  next_article;
		   };
 typedef struct what_ent_is entity;


struct coordinates {
		     double x_value;
		     double y_value;
		     double r_value;  /* so we can store radiuses */
		   };

typedef struct coordinates coords;


/* this is the second c program */


main()
	{
		entity entity;
		FILE *dwgptr;
                long ent_start;
		long block_names;
		long done;
	        if((dwgptr = fopen("test.dwg","rb")) == NULL){
		    printf("\nFor some reason cannot open file ");
		    exit(1);}

                fread(version,sizeof(version),1,dwgptr);
		fread(&ent_start,sizeof(ent_start),1,dwgptr);
		fread(&block_names,sizeof(block_names),1,dwgptr);
		fseek(dwgptr,ent_start,0); /* go to first entity */

		printf("\nVersion %s Entities start at %lx\n",version,ent_start);
		printf("\nEntity      Size     Layer");
                while(done != block_names){
			fread(&entity,sizeof(entity),1,dwgptr);
			  switch(entity.name){
			     case 1:
				   printf("\nLINE     %d bytes      %d",entity.size,entity.layer);
                                   fseek(dwgptr,entity.size - sizeof(entity),1);
				   break;
			     case 2:
				   printf("\nPOINT    %d bytes      %d",entity.size,entity.layer);
				   fseek(dwgptr,entity.size - sizeof(entity),1);
				   break;

			     case 3:
				   printf("\nCIRCLE   %d bytes      %d",entity.size,entity.layer);
				   fseek(dwgptr,entity.size - sizeof(entity),1);
				   break;
                             case 7:
				   printf("\nTEXT     %d bytes      %d",entity.size,entity.layer);
				   fseek(dwgptr,entity.size - sizeof(entity),1);
				   break;
			     case 8:
				   printf("\nARC      %d bytes      %d",entity.size,entity.layer);
				   fseek(dwgptr,entity.size - sizeof(entity),1);
				   break;

		            default:
				   printf("\n** NOT READY FOR THESE YET  **");
           			   fseek(dwgptr,entity.size - sizeof(entity),1);
				   break; }
                        done = ftell(dwgptr);
                    }

	}


/* this is the balance of the dxf translator
   please note that it will only do lines
   the balance of the program will be available
   at your request          */


/* my first dxf translator
   (c) 1985,88 Pan-Dimensional Research
   5901 Colfax Ave.
   North Hollywood, CA.  91601
   Michael Liska

   March 1, 1988

   for educational purposes only
   presented here for the non profit exclusive use of AutoCad end users only
   Pan-Dimension Research makes no warranty and
   provides no support for the following program   */

/* for compiling with Borland use large model : nested comments on */


#include <stdio.h>      /* use the standard i/o package */
#include <math.h>       /* so we can use big numbers    */
#include <string.h>     /* for string handling          */
FILE *dwgptr;           /* file handle for binary file  */
FILE *dxfptr;           /* file handle for the dxf file */

char version[20];       /* first 20 bytes of a r9 file 19 bytes for 2.6 */
char color;
char line;

/*  defines to make the source easier to read    */

#define DELETED	0x80	/* deleted flag : yes Virginia you can super unerase */
#define BYFLAG  0x03    /* does it have BYLAYER info */
#define ZFLAGS	0x0c	/* if BYCOLOR && BYBLOCK  floating entity */
#define NORMAL  0x0     /* is it a set color using color command      */

#define LINE	1
#define POINT	2
#define CIRCLE  3
#define TEXT    7
#define ARC     8

struct what_ent_is {
			char name;
			char byflags;
			char size;
			char layerbits;
			char layer;
			char nastyflags;
			int  nastyint;

		   };

struct coordinates {
			double x;
			double y;
			double rest;
		   };
struct floats3d {
			double elev;
			double thick;
		};
struct floats3d zfloats;
typedef struct what_ent_is ENTS;
typedef struct coordinates COORDS;
void extra();
main(count,name)
char *name[];
int count;
	{
                /* local variables structure first */

	       ENTS entity;
	       COORDS coords;
               struct {
			char bytypes[2];
		      } bynums;

	       long ent_start, ent_stop, done;
               int numfloats,numchars;
	       char font, *text_buff;

               /* check command line arguments */

	       if(!count){
		    printf("\nUsage dxfout filename");  /* show usage */
		    exit(1);} /* return 1 for batch file */

	       strcpy(version,name[1]);  /* never waste a perfectly good buffer */
	       strcat(version, ".dwg");  /* place extension on file */

	       if((dwgptr = fopen(version,"rb")) == NULL){
		     printf("\nDWG file open error");
		     exit(1);}     /* something happened can't open file */
	      strcpy(version,name[1]);
              strcat(version, ".dxf");    /* build out file name */
	      if((dxfptr = fopen(version,"w")) == NULL){
                     printf("\nDXF file open error");
		     exit(1);}     /* something happened to outfile */

	      /* at this point both files are open and we are ready to go */
           if(
              fread(&version,sizeof(version),1,dwgptr) != 1 ||
	      fread(&ent_start,sizeof(ent_start),1,dwgptr) != 1 ||
	      fread(&ent_stop,sizeof(ent_stop),1,dwgptr) != 1)

			{ printf("\nSomething happened reading DWG file");
			  fclose(dwgptr);
			  fclose(dxfptr);
			  exit(1); };

	      /* ready to read entities  */
	      fseek(dwgptr,ent_start,0);
              done = ftell(dwgptr);   /* in case you try to read an empty drawing */
	      fprintf(dxfptr,"\n   0\nSECTION\n  2\nENTITIES\n   0");
	      while(done != ent_stop){

                       color = line = numchars = numfloats = NORMAL;
                       fread(&entity,sizeof(entity),1,dwgptr);
			  if((entity.name & DELETED) != DELETED){
				switch(entity.byflags & BYFLAG){

					case 1:
                                              fread(&bynums,sizeof(char),1,dwgptr);
					      color = (char)bynums.bytypes[0];
					      numchars = 1;
					      break;

				        case 2:
					      fread(&bynums,sizeof(char),1,dwgptr);
					      line = (char)bynums.bytypes[0];
                                              numchars = 2;
					      break;

				        case 3:
					      fread(&bynums,sizeof(bynums),1,dwgptr);
					      color = (char)bynums.bytypes[0];
					      line = (char)bynums.bytypes[1];
					      numchars = 3;
					      break;

				         default:
					       numfloats = (char)NULL;
					       break;  }

				   switch(entity.byflags & ZFLAGS){

	                                 case 1:
						fread(&zfloats,sizeof(double),1,dwgptr);
						numfloats = 1;
						break;

				         case 2:
						fread(&zfloats,sizeof(double),1,dwgptr);
						numfloats = 2;
						break;

				          case 3:
						fread(&zfloats,sizeof(zfloats),1,dwgptr);
						numfloats = 3;
						break;

					  default :
						numfloats = (char)NULL;
		    				break; }}
                       else
			   fseek(dwgptr,entity.size - sizeof(entity),1);

                     switch(entity.name){

                        case LINE :
		printf("\ncase line");
				fread(&coords, 2 * sizeof(double),1,dwgptr);
				fprintf(dxfptr,"\nLINE\n  8\n%d",entity.layer);
                                extra(numchars,numfloats);
				fprintf(dxfptr,"\n 10\n%lf\n 20\n%lf",coords.x,coords.y);
				fread(&coords,2 * sizeof(double),1,dwgptr);
				fprintf(dxfptr,"\n 11\n%lf\n 21\n%lf\n  0",coords.x,coords.y);
                                break;

			default :
				exit(10);}


                    done = ftell(dwgptr);
                    } /* end of while */

		fprintf(dxfptr,"\nENDSEC\n  0\nEOF");
		fclose(dwgptr);
		fclose(dxfptr);
                printf("\nProcessing complete....\n\n\n\n\n");
	} /* end of main */

void extra(numchars,numfloats)
int numchars,numfloats;
	{
printf("\nwe are in function extra %d %d\n\n\n\n",numchars,numfloats);
		if(numchars == 1)
			fprintf(dxfptr,"\n 62\n%6d",color);
                if(numchars == 2)
			fprintf(dxfptr,"\n  6\n%d",line);
		if(numchars == 3)
			fprintf(dxfptr,"\n  6\n%d\n 62\n%d",line,color);

	        if(numfloats == 1)
			fprintf(dxfptr,"\n 38\n%lf",zfloats.elev);
		if(numfloats == 2)
			fprintf(dxfptr,"\n 39\n%lf",zfloats.elev);
		if(numfloats == 3)
			fprintf(dxfptr,"\n 38\n%lf\n 39\n%lf",zfloats.elev,zfloats.thick);
printf("\nwe are out of extra\n\n\n\n");
	 }
