(defun c:ROT ()
	(setvar "CMDECHO" 0)
		(if (null nz) (command "block" 1 "0,0" ""))
		(command "block" 1 "yes")
		(command (setq c (getpoint "rotation center point: ")))
		(while (setq p1 (getpoint "select objects "))
			(command p1))
		(command "")
	(setq a (getangle c "enter rotation angle: "))
	(setq a (angtos a 0 5))
	(command "insert" "*1" c 1 a)
	(setq nz 1)
)
;
;  C:ROT rotates any objects, any angle, around a specified
;center.  The objects selected must be individually picked
;with the pointer and may not be chosen with "last" or a
;window.  This means that the drawing must be sufficiently
;zoomed in to be able to select all the desired objects.
;(I would like to be able to use the "objects or window or last"
;method but as yet have not been able to do so.)
